/*
 * holidayinfoprovider.js
 *
 *  Created on: 11.10.2016
 *      Author: Holger Dahm
 *
 * Note: adapt this to your specific needs
 */

// (default) options used in this infoprovider
// Note: call setOptions() before doing anything!
var options;

function setOptions(values) {
	options = values;
}

// initialize appcontroller for
// json or xml request, caching as well as message to pebble send operations
// Note: call setAppController() before doing anything!
var appcontroller;

function setAppController(controller) {
	appcontroller = controller;
}

var HOLIDAYS_ID           = 'holidays'; // not used due to problems expected with chinese chars

/*
 * generic module interace
 */

module.exports = {
		// set (default) options used in this module
		setOptions : setOptions,

		// set app controller used in this module
		setAppController : setAppController,

		// ID used for caching module infos
		HOLIDAYS_ID : HOLIDAYS_ID
};



// module properties

// none



// module functions

/*
 * load public holidays and send them to pebble
 */

function fetchPublicHolidays(mode) {
    if (options.calendar == 0) {
        // no calendar requested nothing remains to do
        appcontroller.appMessageQueue.push({
            "message" : {
                "nodata" : "no calendar mode"
            }
        });
        appcontroller.sendAppMessage(true);
        return;
    }

    // Debug content - begin
/*    appcontroller.appMessageQueue.push({
        "message" : {
            "dateContent" : "3|7|Holgis Day|13|Sonni Day|25|Pooh Day|e"
        }
    });
    appcontroller.sendAppMessage(true);

    return;*/
    // Debug content - end

    var now = new Date();

    var query = encodeURI("&month=" + (now.getMonth() + 1) + "&year=" + now.getFullYear() + "&country=" + options.calLocation);
    var url = "http://kayaposoft.com/enrico/json/v1.0/?action=getPublicHolidaysForMonth" + query;

    appcontroller.startJSONRequest(url,
        function(res) {
            var index = 0;
            var dateContent = "";
            res.forEach(function(element, index1, array) {
                var day     = element.date.day;
                var content = appcontroller.pebblehelpers.decodeHTML(element.localName).replace(/\|/g,' ');

                index++;
                dateContent += day + "|" +
                               content + "|";
            });
            if (index == 0) {
                appcontroller.appMessageQueue.push({
                    "message" : {
                        "nodata" : "no holidays"
                    }
                });
            }
            else {
                appcontroller.appMessageQueue.push({
                    "message" : {
                        "dateContent" : index + "|" + dateContent + "e"
                    }
                });
            }
        }
    );
}



/*
 * individual module interace
 */

module.exports.fetch = fetchPublicHolidays;
